
/*c
from luCommon import *

"""List the nodes that the plugin provides here and there types"""
nodes = { "luBox" : "kLocatorNode", "luCapsule" : "kLocatorNode", "luForce" : "kLocatorNode" }

""" MOST OF THIS FILE IS AUTOGENERATED, YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS LINE  """
for i in nodes.keys():
	o('#include <%s.h>' % i)
c*/
#include <luBox.h>
#include <luCapsule.h>
#include <luForce.h>
//e

#include <maya/MFnPlugin.h>

MStatus initializePlugin( MObject obj )
{
	MStatus stat;

	MFnPlugin fnPlugin( obj, "Luke", "1.0", "Any");

/*c
for i in nodes.keys():
	o('	 //Register the %s with maya.' % i )
	o('        stat = fnPlugin.registerNode( %s::typeName, %s::typeId, %s::creator, %s::initialize, MPxNode::%s );' % (i,i,i,i,nodes[i]))
	o('')
	o('        //Check that the %s node was registered.' % i )
	o('        if ( stat != MS::kSuccess ) stat.perror( "Could not register the %s node." );' % i )
	o('')
	o('')
c*/
	 //Register the luBox with maya.
        stat = fnPlugin.registerNode( luBox::typeName, luBox::typeId, luBox::creator, luBox::initialize, MPxNode::kLocatorNode );

        //Check that the luBox node was registered.
        if ( stat != MS::kSuccess ) stat.perror( "Could not register the luBox node." );


	 //Register the luCapsule with maya.
        stat = fnPlugin.registerNode( luCapsule::typeName, luCapsule::typeId, luCapsule::creator, luCapsule::initialize, MPxNode::kLocatorNode );

        //Check that the luCapsule node was registered.
        if ( stat != MS::kSuccess ) stat.perror( "Could not register the luCapsule node." );


	 //Register the luForce with maya.
        stat = fnPlugin.registerNode( luForce::typeName, luForce::typeId, luForce::creator, luForce::initialize, MPxNode::kLocatorNode );

        //Check that the luForce node was registered.
        if ( stat != MS::kSuccess ) stat.perror( "Could not register the luForce node." );


//e
	//Mel scripts which are packaged with this plugin
	#include<luLoadMelScripts.h>

	return stat ;
}

MStatus uninitializePlugin( MObject obj)
{
// use the plugin function set to unload the plugin
	MFnPlugin fnPlugin( obj );

	MStatus stat;
	#include<luUnloadMelScripts.h>
/*c
for i in nodes.keys():
	o('	 //Register the %s with maya.' % i )
	o('        stat = fnPlugin.deregisterNode( %s::typeId );' % i)
	o('')
	o('        //Check that the %s node was deregistered.' % i )
	o('        if ( stat != MS::kSuccess ) stat.perror( "Could not deregister the %s node." );' % i )
	o('')
	o('')
c*/
	 //Register the luBox with maya.
        stat = fnPlugin.deregisterNode( luBox::typeId );

        //Check that the luBox node was deregistered.
        if ( stat != MS::kSuccess ) stat.perror( "Could not deregister the luBox node." );


	 //Register the luCapsule with maya.
        stat = fnPlugin.deregisterNode( luCapsule::typeId );

        //Check that the luCapsule node was deregistered.
        if ( stat != MS::kSuccess ) stat.perror( "Could not deregister the luCapsule node." );


	 //Register the luForce with maya.
        stat = fnPlugin.deregisterNode( luForce::typeId );

        //Check that the luForce node was deregistered.
        if ( stat != MS::kSuccess ) stat.perror( "Could not deregister the luForce node." );


//e

	return stat;
}
