import cog

def o(val):
	cog.outl(val)

""" The C Pre Processor directives """
def genCPP( info ):
	o('#include<%s.h>' % (info.name))
	o('#define NODENAME %s ' % (info.name))

""" Initialise The Static Member Functions """
def genStaticMembers( info ):
	o('const MTypeId NODENAME::typeId( %s );' % (info.typeid) )
	o('const MString NODENAME::typeName( "%s" );' % (info.name) )
	
	for i in info.compoundAttributes.keys():
		o('MObject NODENAME::m_a%s ;' % i.capitalize() )
		for j in info.compoundAttributes[i]:
			o('MObject NODENAME::m_a%s ;' % (i[0:3].capitalize()+j.capitalize()) )

""" Create The Attributes In The Initialize Function """
def genAttributeInitialisers( info, setArray=0, setKeyable=0 ):
	for i in info.compoundAttributes.keys():
		icap = i.capitalize()
		cmp_name = 'cAttr_' + icap 
		mob_name = 'Attr_' + icap 
		o('        MFnCompoundAttribute %s;' % cmp_name )
		o('        m_a%s=%s.create("%s","%s");' % (icap,cmp_name,i,i.lower()) )
		o('        %s.setStorable(true);' % cmp_name )
		if setKeyable:
			o('        %s.setKeyable(true);' % cmp_name )	
		else:
			o('        %s.setKeyable(false);' % cmp_name )
		o('        %s.setReadable(true);' % cmp_name )
		if setArray :
			o('        %s.setArray(true);' % cmp_name )
		o('')
		o('	MFnNumericAttribute n%s;' % mob_name )
		for j in info.compoundAttributes[i]:
			jcap = j.capitalize()
			scmp_name = 'cAttr_' + jcap 
			smob_name = 'Attr_' + jcap 
			o('        m_a%s%s = n%s.create("%s","%s",MFnNumericData::kDouble);' % (icap[0:3],jcap,mob_name,j,jcap.lower()) )
			o('        n%s.setStorable(true);' % mob_name )
			if setKeyable:
				o('        n%s.setKeyable(true);' % mob_name )	
			else:
				o('        n%s.setKeyable(false);' % mob_name )
			o('        n%s.setHidden(false);' % mob_name )
			o('        n%s.setChannelBox(true);' % mob_name )
			o('        n%s.setReadable(true);' % mob_name )
			o('        n%s.setDefault(1.0);' % mob_name )
			o('        %s.addChild(m_a%s%s);' % (cmp_name,icap[0:3],jcap))
			o('')
			
	for i in info.compoundAttributes.keys():
		o('	addAttribute(m_a%s) ;' % i.capitalize() )
		for j in info.compoundAttributes[i]:
			o('        addAttribute(m_a%s) ;' % (i[0:3].capitalize()+j.capitalize()) )

""" Generate some useful getter functions to access attribute data with """
def genAttributeGetters(info):
	for i in info.compoundAttributes.keys():
		for j in info.compoundAttributes[i]:
			a_name = i[0:3].capitalize() + j.capitalize()
			mem_name = 'm_a' + a_name
			fun_name = 'get' + a_name
			o('double NODENAME::%s() const {' % fun_name)
			o('	MPlug dataP(thisMObject(),%s);' % mem_name )
			o('	double dataD;')
			o('	dataP.getValue(dataD);')
			o('	return dataD;')
			o('}')
""" This generates the attribute dependencies. This is how maya knows when to call the compute function """
""" It is not compulsary for the attribute effects attribute to be set which is why we check for its existance with exceptions in this function """
def genAttributeAffects(info):
	try:
		for i in info.attributeAffects.keys():
			o('	//Tell Maya which output attributes the %s input attribute affects' % i)
			for j in info.attributeAffects[i]:
				o('        attributeAffects(m_a%s,m_a%s);' % (i.capitalize(),j.capitalize()) )
			o('')
	except AttributeError:
		pass
			
""" Generate the C Pre Processor Directives for the header file """
def hgenCPP(info):
	o('       #ifndef __%s_H__' % info.name.upper())
	o('       #define __%s_H__' % info.name.upper())
	o('       #define NODENAME %s' % info.name )


""" Generate some useful getter function prototypes to access attribute data with """
def hgenAttributeGetters(info):
	for i in info.compoundAttributes.keys():
		o('	// Getters for the %s attributes' % i )
		for j in info.compoundAttributes[i]:
			o('                double get%s%s() const ;' % (i[0:3].capitalize(),j.capitalize()))

""" Generate the static memebers which are handles to the nodes attributes """
def hgenStaticMembers(info):
	for i in info.compoundAttributes.keys():
		o('		static MObject m_a%s ;' % i.capitalize() )
		for j in info.compoundAttributes[i]:
			o('                static MObject m_a%s ;' % (i[0:3].capitalize()+j.capitalize()) )

