/*c

from luCommon import *

class nodeInfo:
	name = "luForce"
	typeid = "0x90000"
	compoundAttributes =	{ "strengths" : ["strength"] }

genCPP(nodeInfo)
c*/
#include<luForce.h>
#define NODENAME luForce 
//e

#include <maya/MColor.h>
#include <glDrawUtils.h>

/*c
genStaticMembers(nodeInfo)
c*/
const MTypeId NODENAME::typeId( 0x90000 );
const MString NODENAME::typeName( "luForce" );
MObject NODENAME::m_aDimensions ;
MObject NODENAME::m_aDimStrength ;
//e

void NODENAME::init(){
	MFnDependencyNode fc(thisMObject());
	
	MPlug pPlug = fc.findPlug("lpx") ;
	pPlug.setChannelBox(false);

	pPlug = fc.findPlug("lpy") ;
	pPlug.setChannelBox(false);	

	pPlug = fc.findPlug("lpz") ;
	pPlug.setChannelBox(false);
	
	pPlug = fc.findPlug("lsx") ;
	pPlug.setChannelBox(false);
	
	pPlug = fc.findPlug("lsy") ;
	pPlug.setChannelBox(false);
	
	pPlug = fc.findPlug("lsz") ;
	pPlug.setChannelBox(false);
}


void NODENAME::draw( M3dView& view, const MDagPath& DGpath, M3dView::DisplayStyle style, M3dView::DisplayStatus status)
{
	if(subInit){
		init();
		subInit = false ;
	}
	
	MColor col = colorRGB( status );
	
	double Height = 1; //getDimHeight();
	double Width = 1; //getDimWidth() ;	
	double Depth = 1; //getDimDepth() ;	

	// think glPushMatrix()
	view.beginGL();

	// this makes a copy of the current openGL settings so that anything
	// we change will not affect anything else maya draws afterwards.
	glPushAttrib( GL_CURRENT_BIT );
	glLineWidth(2);
	
	if(status == M3dView::kLead)
			glColor4f(0,1,0,0.5f);
		else
			glColor4f(col.r,col.g,col.b,0.5f);
	
	glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		drawForce();
	glDisable(GL_BLEND);
	glLineWidth(1);
	// restore the old openGL settings
	glPopAttrib();

	// think glPopMatrix()
	view.endGL();
}

bool NODENAME::isBounded() const {
	return true;
}

MBoundingBox NODENAME::boundingBox() const
{
	MBoundingBox bbox;
	
	bbox.expand( MPoint( 0.0f, 0, 0.0f ) );
	bbox.expand( MPoint( 0.0f,-6, 0.0f ) );

	bbox.expand( MPoint( 1, 0.0f, 0.0f ) );
	bbox.expand( MPoint( -1, 0.0f, 0.0f ) );

	bbox.expand( MPoint( 0.0f, 0.0f, 1 ) );
	bbox.expand( MPoint( 0.0f, 0.0f,-1 ) );

	return bbox;
}

void* NODENAME::creator()
{
	NODENAME *newLoc = new NODENAME();
	newLoc->subInit = true ;
	return newLoc ;
}

MStatus NODENAME::initialize()
{
/*c
genAttributeInitialisers( nodeInfo, setKeyable=1 )
c*/
        MFnCompoundAttribute cAttr_Dimensions;
        m_aDimensions=cAttr_Dimensions.create("dimensions","dimensions");
        cAttr_Dimensions.setStorable(true);
        cAttr_Dimensions.setKeyable(true);
        cAttr_Dimensions.setReadable(true);

	MFnNumericAttribute nAttr_Dimensions;
        m_aDimStrength = nAttr_Dimensions.create("strength","strength",MFnNumericData::kDouble);
        nAttr_Dimensions.setStorable(true);
        nAttr_Dimensions.setKeyable(true);
        nAttr_Dimensions.setHidden(false);
        nAttr_Dimensions.setChannelBox(true);
        nAttr_Dimensions.setReadable(true);
        nAttr_Dimensions.setDefault(1.0);
        cAttr_Dimensions.addChild(m_aDimStrength);

	addAttribute(m_aDimensions) ;
        addAttribute(m_aDimStrength) ;
//e
	return MS::kSuccess;
}

/*c
genAttributeGetters(nodeInfo)
c*/
double NODENAME::getDimStrength() const {
	MPlug dataP(thisMObject(),m_aDimStrength);
	double dataD;
	dataP.getValue(dataD);
	return dataD;
}
//e

#undef NODENAME

