//
/*c
from luCommon import *

class nodeInfo:
	name = "luForce"
	typeid = "0x90000"
	compoundAttributes =	{ "dimensions" : ["strength"] }

hgenCPP(nodeInfo)
c*/
#ifndef __LUFORCE_H__
#define __LUFORCE_H__
#define NODENAME luForce
//e
	#include <maya/MPxLocatorNode.h>
	#include <maya/MString.h>
	#include <maya/MTypeId.h>
	#include <maya/MVector.h>
	#include <maya/MDataBlock.h>
	#include <maya/MDataHandle.h>
	#include <maya/M3dView.h>
	#include <maya/MDistance.h>
	#include <maya/MFnUnitAttribute.h>
	#include <maya/MFnNumericAttribute.h>
	#include <maya/MFnMessageAttribute.h>
	#include <maya/MFnTypedAttribute.h>
	#include <maya/MFnCompoundAttribute.h>
	#include <maya/MFnDependencyNode.h>
	#include <maya/MPxManipContainer.h>
	#include <maya/MPointArray.h>
	#include <maya/MObject.h>
	#include <maya/MGlobal.h>
	#include <math.h>


class NODENAME : public MPxLocatorNode {
	public:

		virtual void draw( M3dView&,
						const MDagPath&,
						M3dView::DisplayStyle,
						M3dView::DisplayStatus);

		/// \brief	this function can tell maya whether the locator node has a volume
		/// \return	true if bounded, false otherwise.
		///
		virtual bool isBounded() const;

		/// \brief	returns the bounding box of the locator node
		/// \return	the nodes bounding box
		virtual MBoundingBox boundingBox() const;

		/// \brief	this function is called by mata to return a new instance of our locator node
		/// \return	the new node
		static void* creator();

		/// \brief	this function creates a description of our node
		/// \return	The status code
		static MStatus initialize();
		
		virtual void init();

/*c
hgenAttributeGetters(nodeInfo)
c*/
	// Getters for the dimensions attributes
                double getDimStrength() const ;
//e

	// type information
	public:

		/// the unique type ID of our custom node. Used internally by maya for fileIO.
		static const MTypeId typeId;

		/// the unique type name of our custom node. Mainly for mel purposes.
		static const MString typeName;
/*c
hgenStaticMembers(nodeInfo)
c*/
		static MObject m_aDimensions ;
                static MObject m_aDimStrength ;
//e

		bool subInit ;
	};

#undef NODENAME
#endif
