"""
	This script takes the contents of the files listed in melscripts and packages them into the file specified by outfile.
	This allows a chunk of mel scripts to be run when the plugin is loaded.
"""

"""Files to be executed after the plugin loads"""
def melGen( loadoutfile, loadmelscripts):
	outfile = open(loadoutfile,"w")
	"""Pack mel commands to be unpacked when the plugin loads."""
	for i in loadmelscripts:
		mel = open(i,"r")
		line = mel.readline()
		melstring = ""
		while( len(line) > 0 ):
			line = line.replace('\n','')
			line = line.replace('\\','\\\\')
			line = line.replace('"',r'\"')
			line = ( '"%s\\n"\n' % line )
			melstring = melstring + line
			line = mel.readline()
		if melstring == "":
			melstring = '""'
		outfile.write('stat = MGlobal::executeCommand(%s);' % melstring)
		outfile.write('\nif (stat != MS::kSuccess) stat.perror("Plugin failed to execute the mel script provided by %s");\n' % i)
		mel.close()
	outfile.close()
	
"""List the mel scripts to be packaged with this plugin"""
"""Files to be executed after the plugin loads"""
melGen("luLoadMelScripts.h",["luUtils.mel"])
"""Files to be executed before the plugin unloads"""
melGen("luUnloadMelScripts.h",["luPluginUnload.mel"])
