#!/usr/bin/env python
"""
    This file does preproccessing.
    For the moment the following things are done.
        - Convert cog shorthand to real cog
        - Preproccess with cog ( code generator )
        - Convert real cog back to cog shorthand
"""

from sys import stdin,stdout,argv,exit
from os import system,getpid

def toCog(lines):
    """
        Converts file to a cog readable file
    """
    lines = lines.replace("/*c","/*[[[cog")
    lines = lines.replace("c*/","]]]*/")
    lines = lines.replace("//e","//[[[end]]]")
    return lines

def fromCog(lines):
    """
        Converts file from cog readable file to special programmable file.
    """
    lines = lines.replace("/*[[[cog","/*c")
    lines = lines.replace("]]]*/","c*/")
    lines = lines.replace("//[[[end]]]","//e")
    return lines

def writeLines(filename,lines):
    f = open(filename,"w")
    f.write(lines)
    f.close()

def readLines(filename):
    f = open(filename,"r")
    lines = f.read()
    f.close()
    return lines

if len(argv) != 3:
    stdout.write("Wrong arguements\npyMacro inputfile outputfile")
    exit(1)

input = argv[1]
output = argv[2]

from_name = "/tmp/sdhfjsdhjfbhf_pyMacroShizzamna_to_%s" % getpid()

writeLines( from_name, toCog( readLines(input) ) )

system("cog.py -r %s > /dev/null 2> /dev/null" % from_name)

writeLines( output, fromCog( readLines(from_name) ) )

system("rm %s" % from_name)

