import luyaODE as luya ; reload(luya)
import fuzzyRules as rules ; reload(rules)
from pyFuzzy import *
from maya.mel import *
from mayaUtils import *

def init(g):
    g.w = luya.World( gravity=(0,0,0), ground=False)
    g.Followers = returnByName("FollowerCollide")
    
    #The Distance input variable
    u = Stepper(-50, 10000,[ -1000000 , -10, 0, 10, 20, 10000 ])
    g.Distance = InputVariable (u.lower,u.upper,(
                              ("TooNear",     Linear(u(0),u(2)), Linear(u(2),u(3))  ),
                              ("Perfect",       Linear(u(2),u(3)), Linear(u(3),u(4))  ),
                              ("TooFar",        Linear(u(3),u(4)), Linear(u(4),u(5))  )
                      ))
                      
    #The Force output variable
    u = Stepper(-200, 200,[ -2, -2, 0, 10, 20 ])
    g.Force = OutputVariable (u.lower,u.upper,(
                              ("Reverse",   Linear(u(0),u(1)), Linear(u(1),u(2))  ),
                              ("Stop",         Linear(u(1),u(2)), Linear(u(2),u(3))  ),
                              ("Speedup",  Linear(u(2),u(3)), Linear(u(3),u(4))  )
                      ))                      
    g.rules = rules.interpret\
    ("""
       if Distance is TooNear  : Force = Reverse
       if Distance is Perfect   : Force = Stop
       if Distance is TooFar    : Force = Speedup
    """)

def run(g):
    Distance = g.Distance
    Force = g.Force
    
    k = 0
    for F in g.Followers :
        Distance.fuzz(   ( Translate(F) - Translate("Leader") ).length()    )
        Force.begin() ; exec( g.rules )
        setAttr( "Push%s.strength" % k, Force.defuzz() )
        k+=1
    
    g.w.step(0.05)
    
def end(g):
    pass
