from maya.mel import *
from maya.api import MVector, MQuaternion, MEulerRotation
from mayaUtils import *

import luyaBullet as luya
from luyaBullet import *
reload(luya)

import luyaUtils as lu
reload(lu)
from fuzzyApi import *
import fuzzyApi
reload(fuzzyApi)
from fuzzyRules import *
from math import pi,degrees,radians
halfPi = pi / 2

def init(g):
    """ The Physics Part """
    g.w = luya.World()
    
    g.log = open("/bacva3/ltitley/Devel/Luya/fuzzy_logic/fuzzy.txt","w")
    
    g.Torque = lu.PID( 1, 0 , 0 )
    
    g.Thi = g.w.dynamics.shin_knee_thi.body 
    g.w.dynamics.shin_knee.joint.SetLimit( 5, -10, 10 )
    
    g.last = 0
    
    
def run(g):
    knee = Translate("knee")
    thi = (Translate("thi") - Translate("knee")).normal()
    yAxis = (Translate("AimTip") - Translate("AimBase")).normal()
    zAxis = ( yAxis ^ MVector( 0, 1, 0 ) ).normal()
    xAxis = ( zAxis ^ yAxis ).normal()
    
    Translate( "ax", (xAxis*3)+knee )
    setKeyframe( "ax" )
    
    Translate( "az", (zAxis*3)+knee )
    setKeyframe( "az" )
    
    """ Work out the current error values """
    Error = 90 - degrees( thi.angle( xAxis ) )
    Solution = g.Torque( Error )
    
    g.log.write("Frame: %s Error: %s Solution: %s\n" % ( g.time, Error, Solution ) )
    
    E = MQuaternion( Solution, zAxis ).asEulerRotation()
    
    if g.time == 2:
        g.Thi.applyTorque( btVector3( 0, 0, 1000 ) )
    
    current = btVector3ToMVector( g.Thi.getAngularVelocity() )
    
    if g.time == 100:
        accel = current - g.last
        new = - current * accel
        g.Thi.applyTorque( btVector3( 0, 0, new ) )
    
    g.last = current
    
    g.w.step()

def end(g):
    g.log.close()
    del g.w
 