import luyaODE as luya
reload(luya)
import time
from luyaUtils import *

from maya.mel import *
from mayaUtils import *
from math import pi

N = None

## Called on a name to return its long name. This only works if the short name is unique.
def fullname( name ):
    sl = ls(sl=N)
    select(cl=N)
    select(name)
    fullname = ls(sl=N,l=N)[0]
    select(cl=N)
    if len(sl) > 0:
        select(sl,add=N)
    return fullname

def lockStops( world, jointName, strength=10000, xStop=0.0000001, yStop=0.0000001, zStop=0.0000001 ):
    motor = world.joints[fullname(jointName)].motor
    motor.setParam(luya.ParamFMax,strength)
    motor.setParam(luya.ParamLoStop,-xStop)
    motor.setParam(luya.ParamHiStop,xStop)
    motor.setParam(luya.ParamFMax2,strength)
    motor.setParam(luya.ParamLoStop2,-yStop)
    motor.setParam(luya.ParamHiStop2,yStop)
    motor.setParam(luya.ParamFMax3,strength)
    motor.setParam(luya.ParamLoStop3,-zStop)
    motor.setParam(luya.ParamHiStop3,zStop)

def correctJoint( w, ob1, ob2, reference, strength=10 ):
    joint = w.joints[fullname( ob2 )]
    current = Translate(ob1) - Translate(ob2)
    target = reference.normal()
    
    Axis = target ^ current
    Error = target.angle( current )
    Euler = MQuaternion( joint.pid(Error), Axis ).asEulerRotation()
    
    joint.motor.setParam( luya.ParamVel,  -Euler.x*strength )
    joint.motor.setParam( luya.ParamVel2, -Euler.y*strength )
    joint.motor.setParam( luya.ParamVel3, -Euler.z*strength )

def init(g):
    ###The Physics Part
    strength = 10000000
    g.startT = time.time()
    g.w = luya.World(ground=True)
    
    lockStops( g.w, fullname( "Physics_LAnkle" ),yStop=pi/4)
    lockStops( g.w, fullname( "Physics_RAnkle" ),yStop=pi/4)
    
    lockStops( g.w, fullname( "Physics_SpineB" ))
    lockStops( g.w, fullname( "Physics_SpineC" ))
    lockStops( g.w, fullname( "Physics_LHip" ) )
    lockStops( g.w, fullname( "Physics_RHip" ) )
    
    g.restVectors = {}
    

def run(g):
    correctJoint( g.w, "Physics_ShinL", "Physics_LAnkle",  MVector(0,1,0.2), 20 )
    correctJoint( g.w, "Physics_ShinR", "Physics_RAnkle",  MVector(0,1,0.2), 20 )
    
    correctJoint( g.w, "Physics_ThiL", "Physics_LKnee",  MVector(0,1,-0.2), 20 )
    correctJoint( g.w, "Physics_ThiR", "Physics_RKnee",  MVector(0,1,-0.2), 20 )
    
    correctJoint( g.w, "Physics_Torso", "Physics_SpineB",  MVector(0,1, -0.3), 20 )
    correctJoint( g.w, "Physics_Chest", "Physics_SpineC",  MVector(0,1, -0.3), 20 )
    
    correctJoint( g.w, "Physics_Stomach", "Physics_LHip",  MVector(0,1, 0), 20 )
    correctJoint( g.w, "Physics_Stomach", "Physics_RHip",  MVector(0,1, 0), 20 )
    
    g.w.step(0.05)

def end(g):
    print ( time.time() - g.startT )
