from maya.mel import *
from maya.api import MQuaternion, MEulerRotation
from mayaUtils import *

from pyBullet import *

N = None

def init(g):
    """Parse the scene"""
    g.w = btWorld(btVector3(0,-0.98,0))
    g.boxes = []
    
    for i in ls(type="luBox"):
        parent = listRelatives(i,p=N)[0]
        mass = getAttr(i+".mass")
        width = getAttr(i+".width")
        height = getAttr(i+".height")
        depth = getAttr(i+".depth")
        T = Translate(parent)
        R = MEulerRotation( xform(parent, ws=N, q=N, ro=N ) ).asQuaternion()
        g.w.Box( btVector3(T.x,T.y,T.z), btQuaternion(R.x,R.y,R.z,R.w), mass, height, width, depth )
        
        g.boxes.append(parent)

def run(g):
    k=0
    for i in g.w.getTransforms():
        j = g.boxes[k]
        xform(j,ws=N,matrix=i.getMatrix4x4())
        setKeyframe(j)
        k+=1
        
    g.w.step()

def end(g):
    pass
