from maya.mel import *
from maya.api import MQuaternion, MEulerRotation
from mayaUtils import *

from pyBullet import *

N = None

def splitTransform(T):
    rotation = btMatrix3x3( T[0], T[4], T[8],
                            T[1], T[5], T[9],
                            T[2], T[6], T[10]
                )
    position = btVector3( T[12], T[13], T[14] )
    return (rotation,position)

def init(g):
    """Parse the scene"""
    g.w = btWorld(btVector3(0,-0.98,0))
    g.boxes = []
    
    for i in ls(type="luBox"):
        parent = listRelatives(i,p=N)[0]
        mass = getAttr(i+".mass")
        width = getAttr(i+".width")
        height = getAttr(i+".height")
        depth = getAttr(i+".depth")
        R,T = splitTransform( xform( parent, q=N, ws=N, a=N, matrix=N ) )
        shape = btBoxShape( btVector3(height, width, depth) )
        b = g.w.RigidBody( btTransform(R,T), shape, mass )
        
        print dir( btGeneric6DofConstraint() )
        
        g.boxes.append(parent)

def run(g):
    k=0
    for i in g.w.getTransforms():
        j = g.boxes[k]
        xform(j,ws=N,matrix=i.getMatrix4x4())
        setKeyframe(j)
        k+=1
        
    g.w.step()

def end(g):
    pass
