import maya.mel as mel 
import mayaUtils
reload(mayaUtils)

from math import *
N = None

class atom:
	pass

def isRigidTransform(name):
	"""Given the name of a transform, this returns true if the transform contains """
	shapes = mel.listRelatives(name,f=N,c=N,s=N)
	if len(shapes) > 0:
		nodeType = mel.nodeType(shapes[0])
		if nodeType == "luCapsule":
			return True
		elif nodeType == "luBox":
			return True
	return False

def hasDynamicParent(name):
	#Get the parent
	parent = mel.listRelatives(name,f=N,p=N)
	for i in parent:
		if isRigidTransform(i):
			return i
	for i in parent:
		j = hasDynamicParent(i)
		if j != None:
			return j
	return None

def hasDynamicChild(name):
	#Get the parent
	child = mel.listRelatives(name,f=N,c=N)
	for i in child:
		if isRigidTransform(i):
			return i
	for i in child:
		j = hasDynamicChild(i)
		if j != None:
			return j
	return None

def isDynamicJoint(name):
	"""Given the name of a joint, return true if it is dynamic, also return the name of the parent and child.
		If a joint has no child then it is not dynamic and (False,None,None) is returned.
	"""
	#Get the parent
	parent = hasDynamicParent(name)
	#Get the children
	child = hasDynamicChild(name)
	
	#Check the joint has a child rigid transform, if it does it is a dynamic joint
	if child != None:
		return (True,parent,child)
	else:
		return (False,None,None)
