from maya.api import MGlobal
from math import pi,degrees,radians

class globo:
	"""
		Global containter for all things related to Luya behaviours.
		This is much neater than having loads of global variables.
	"""
	pass

class PID:
    """
    	Proportional Integral Differential Controller
    	Constructor arguments are:
    		kP is the Proportional Constant
    		kI is the Integral Constant ( Default is 0 )
    		kD is the Differential Constant ( Default is 0 )
    """
    def __init__(self,kP,kI=0,kD=0):
        self.lastP = 0
        self.i = 0
        self.kP = kP
        self.kI = kI
        self.kD = kD

    def __call__(self,error):
        p = error
        self.i += self.lastP
        d = self.lastP - p
        v = self.kP*p + self.kI*self.i + self.kD*d
        self.lastP = p
        return v
