"""
 PID Controller for balancing the inverse pendulum
"""

import os
import luya_api as luya
reload(luya)

import fuzzyApi
from fuzzyApi import *
import fuzzyRules as rules
reload(rules)
reload(fuzzyApi)

def Translate(name,t=None):
    if t == None:
        return MVector(xform(name,ws=N,q=N,t=N))
    else:
        xform(name,ws=N,t=(t[0],t[1],t[2]))

########Fuzzy Logic Part
scale  = 180
u = Stepper(-scale,scale,[-scale*2,-scale,0,scale,scale*2])
Angle = InputVariable (u.lower,u.upper,(
    ("-High" , Linear(u(0),u(1)),  Linear(u(1),u(2))),
    ("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3))),
    ("+High" , Linear(u(2),u(3)),  Linear(u(3),u(4)))
))

scale  = 180
u = Stepper(-scale,scale,[-scale*2,-scale,0,scale,scale*2])
AngleO = InputVariable (u.lower,u.upper,(
    ("-High" , Linear(u(0),u(1)),  Linear(u(1),u(2))),
    ("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3))),
    ("+High" , Linear(u(2),u(3)),  Linear(u(3),u(4)))
))

scale  = 1000.0
u = Stepper(-scale,scale,[-scale*2,-scale,0,scale,scale*2])
Torque = OutputVariable (u.lower,u.upper,(
    ("-High" , Linear(u(0),u(1)),  Linear(u(1),u(2))),
    ("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3))),
    ("+High" , Linear(u(2),u(3)),  Linear(u(3),u(4)))
))
del scale

##Rules
if False :
    ruleSet = rules.interpret(\
    """
        if Angle is +High : Torque = -High
        if Angle is -High : Torque = +High
        if Angle is  Zero : Torque = Zero
    """
    )
else:
    ruleSet = rules.interpret(\
        """
            if Angle is -High and AngularVelocity is -High : Torque = +High
            if Angle is +High and AngularVelocity is +High : Torque = -High
            if Angle is +High and AngularVelocity is -High : Torque = Zero
            if Angle is -High and AngularVelocity is +High : Torque = Zero
        """
        )

########Physics Part

#Initialize the world
w = luya.World()

knee = w.dynamics.shin_knee.joint
parent = knee.getBody(0)
child = knee.getBody(1)

cap = luya.ode.AMotor(w.w)
cap.attach(parent, child)

cap.setMode(luya.ode.AMotorEuler)

cap.setAxis( 0, 1, (1,0,0 ))
cap.setAxis( 2, 2, (0,0,1 ))

cap.setAngle(0,0)
cap.setAngle(1,0)
cap.setAngle(2,0)

mstop = 1000

cap.setParam(luya.ParamFMax,100)
cap.setParam(luya.ParamLoStop,-0.0000001)
cap.setParam(luya.ParamHiStop,0.0000001)

cap.setParam(luya.ParamFMax2,100)
cap.setParam(luya.ParamLoStop2,-0.0000001)
cap.setParam(luya.ParamHiStop2,0.0000001)

#cap.setParam(luya.ParamFMax3,1)
#cap.setParam(luya.ParamLoStop3,-luya.pi/2)
#cap.setParam(luya.ParamHiStop3,luya.pi/2)
