""" 
    Given a Current Rotation and and Reference position Computes an Angular Velocity.
"""

import fuzzyApi ; reload(fuzzyApi)
import fuzzyApi ; reload(fuzzyApi)

from mayaUtils import Translate

from fuzzyApi import *
from fuzzyRules import *

from math import degrees,radians
from maya.api import MQuaternion,MVector

class jointTracker:
    def __init__( self, strength=400 ): 
        scale  = 90
        u = Stepper(-scale, scale,[ -2*scale, -scale, scale, 2*scale ])
        self.Angle = InputVariable (u.lower,u.upper,(
            ("Low" , Linear(u(0),u(1)), Linear(u(1),u(2))),
            ("High", Linear(u(1),u(2)), Linear(u(2),u(3)))
        ))
        
        u = Stepper(-strength, strength,[ -2*strength, -strength, strength, 2*strength ])
        self.Torque = OutputVariable (u.lower,u.upper,(
            ("Low" , Linear(u(0),u(1)), Linear(u(1),u(2))),
            ("High", Linear(u(1),u(2)), Linear(u(2),u(3)))
        ))
        
        self.ruleSet = interpret(\
        """
            if Angle is High : Torque = High
            if Angle is Low : Torque = Low
        """
        )

    def __call__( self, Current, Reference=MVector(0,1,0), log=None ):
        """
            Compute the angular velocity.
                run( Current, Reference )
                Current is the Current state
                Reference is where you want to be
            If Reference is not provided then it is set to (0,1,0) the upvector. This will
                compute the solution to the inverse pendulum
        """
        Angle = self.Angle ; Torque = self.Torque
        
        """Grab transform info and turn it into something usable"""
        Reference = Reference.normal()
        Current = Current.normal()
        Axis = ( Reference ^ Current ).normal() # Swap the high low aspect in here
        
        """ Work out the current error values """
        Error = degrees( Current.angle( Reference ) )
    
        """Fuzzify the error values"""
        Angle.fuzz(Error)
        
        """Clean the output Variable"""
        Torque.begin()
        exec(self.ruleSet)
        
        """Defuzz the torque"""
        Solution = Torque.defuzz()
        
        if log != None:
            log.write( "Error: %s Solution: %s " % (Error,Solution) )
        
        return MQuaternion( radians( Solution ),Axis)
