"""
 PID Controller for balancing the inverse pendulum
"""

from maya.api import MVector,MQuaternion
from math import acos,degrees,radians

parentV = MVector(xform("knee",ws=N,q=N,t=N))
thiV = MVector(xform("thi",ws=N,q=N,t=N)) - parentV
thiV.normalize()
upV = Translate("AimTip") - Translate("AimBase")
upV = upV ^ MVector(0,0,1)

if time == 1:
    lastError = 0
    i = 0
else :
    p = 90.0 - degrees(thiV.angle(upV))
    i += lastError
    d = lastError - p
    
    kP = -0.025
    kI = 0.000001 #-0.008
    kD = 0.02 #0.02
    
    torque = kP*p + kI*i + kD*d
    
    lastError = p
    
    #cap.addTorques(0,0,torque)
    cap.setParam(luya.ParamVel3,torque)

for i in range(20):
    w.step(0.02)
