require("custardCream")
require("gd")

local im = gd.createFromJpeg("logo1.jpg")

local xSize = im:sizeX()
local ySize = im:sizeY()

local particles = Particles(xSize*ySize)

local points = particles:getPosition()
local widths = particles:getWidths()
local colours = particles:getColours()
local velocity = particles:getVelocity()

local i = 0
local colour

for x=0, xSize-1 do
	for y=0, ySize-1 do
	
		points:setElement(i, Vector(x-(xSize*0.5), (xSize*0.5)-y, 0))
		colour = im:getPixel(x, y)
		
		colours:setElement(i, Vector(
			(im:red(colour)/255), 
			(im:green(colour)/255), 
			(im:blue(colour)/255) 
			))
			
		widths:setElement(i, Float(1.5))
			
		i = i + 1
		
	end
end

particles:explode(7,6)

--[[
l1 = LightPointPrim()
l1:setFrom(Vector(-5,-2, 0))
l1:setIntensity(30)
Render(l1)

l2 = LightPointPrim()
l2:setFrom(Vector(5,-2, 0))
l2:setIntensity(30)
Render(l2)
]]--

camera:transform(Translate(0, 0, 3000))


Render(particles)
camera:outputTIF("test1d.0.tif")
output("RIB", "test1d.0.rib")
unRender(particles)
	

local c1 = particles
local c2 = particles
local b = nil
for frame=1, 200 do
	unRender(b)
	
	c2 = c1:clone()
	c1:gravity()
	c1:nextFrame()	
	
	b = Blurred(c1, c2)
	Render(b)
	
	camera:outputTIF("test1d."..frame..".tif")
	output("RIB", "test1d."..frame..".rib")			
end

