require("custardCream")
require("gd")

-----------------------------------------------------------------------------------------------
-- point(ray) , plane intersection 
-----------------------------------------------------------------------------------------------
function intersect(rOrigin, rNormal, pOrigin, pNormal)
    -- Calc D for the plane (this is usually pre-calculated
    -- and stored with the plane)

    local D = pOrigin:dot(pNormal);

    -- Determine the distance from rOrigin to the point of
    -- intersection on the plane

    local numer = pNormal:dot(rOrigin) + D;
    local denom = pNormal:dot(rNormal);
    return 0-(numer / denom);
end

-----------------------------------------------------------------------------------------------
-- main stuff:
-----------------------------------------------------------------------------------------------
--[[
Blobby 3
    [1001 0
     1001 16
     1001 32
     0 3 0 1 2]
    [1 0 0 0  0 1 0 0  0 0 1 0  0.176 0.252 0.468 1
     1 0 0 0  0 1 0 0  0 0 1 0  0.916 0.477 0.174 1
     1 0 0 0  0 1 0 0  0 0 1 0  0.478 0.462 0.806 1]
    [""]
]]--

local i = 0
local colour

local amount = 100000
local p = Particles(amount)
p:explode(5,4)

local points = p:getPosition()
local widths = p:getWidths()
local colours = p:getColours()
local velocity = p:getVelocity()

for i=0, widths:size()-1 do
	widths:setElement(i, Float(amount/50000))
end

camera:transform(Translate(0, 0, 1000))
camera:setRes(720, 576)

local c1 = p
local c2 = p
local b1
local b2
local b = nil
for frame=1, 50 do

	for i=0, widths:size()-1 do
		local t =  math.abs(intersect( points:getElement(i), velocity:getElement(i), Vector(0,10,0), Vector(1,1,-0.5) ))
		if t <= 1 then
		--	print("Frame: "..frame.." | "..i.." | "..t)
			velocity:setElement(i, ((Vector(0)-velocity:getElement(i)):scale(Vector(0.8)) ))
		end
	end
	
	local blobbys = Primitive("Blobby")
	blobbys:addPrimVar(PrimVar("", Int(points:size())))
	local bInts = AttributeInt(points:size()*3 + 10)
	local j=0	
	for i=0, points:size()-1 do
		bInts:setElement(j, Int(1001))
		bInts:setElement(j+1, Int(i*16))
		j=j+2
	end
	bInts:setElement(j, Int(0))
	bInts:setElement(j+1, Int(points:size()))
	j=j+2
	for i=0, points:size()-1 do
		bInts:setElement(j, Int(i))
		j=j+1
	end	
	blobbys:addPrimVar(PrimVar("", bInts))
	local bMatrix = AttributeMatrix(points:size())
	for i=0, points:size()-1 do
		bMatrix:setElement(i, Scale(Vector(widths:getElement(i):getData())) * Translate(points:getElement(i)))
	end	
	blobbys:addPrimVar(PrimVar("", bMatrix))
	local bString = AttributeString(1)
	bString:setElement(0, String(""))
	blobbys:addPrimVar(PrimVar("", bString))
	
	if frame == 1 then
		b1 = blobbys
	end
	
	b2 = blobbys
	
	unRender(b)

	c1:gravity()
	c1:nextFrame()	
	
	b = Blurred(b1, b2)
	Render(b)
	
	camera:outputTIF("renders/particles."..frame..".tif")
	output("RIB", "ribs/particles."..frame..".rib")		

	b1 = blobbys

end

