require("custardCream")

-----------------------------------------------------------------------------------------------
-- point(ray) , plane intersection 
-----------------------------------------------------------------------------------------------
function intersect(rOrigin, rNormal, pOrigin, pNormal)
    local D = pOrigin:dot(pNormal);

    local numer = pNormal:dot(rOrigin) + D;
    local denom = pNormal:dot(rNormal);
    return 0-(numer / denom);
end

-----------------------------------------------------------------------------------------------
-- main stuff:
-----------------------------------------------------------------------------------------------

--- settings ---

local planePoint = Vector(0,10,0)
local planeNormal = Vector(0.2,1,-0.4)
local radius = 3
local particleAmount = 500
local particleRate = 12

local startVec = Vector(-10,20,-10)

camera:transform(Translate(0, 0, 500))
camera:setRes(720, 576)
Render(LightPointShadowPrim(Vector(20,20,-20), 1000, Vector(1,1,1), 5, 10))
Render(LightPointShadowPrim(Vector(-20,25,0), 1000, Vector(1,1,1), 5, 10))



--Attribute "visibility" "transmission" ["opaque"]
local trans = Primitive("Attribute")
trans:addPrimVar(PrimVar("", String("visibility")))
local tranT = AttributeString(0,1)
tranT:setElement(0,String("opaque"))
trans:addPrimVar(PrimVar("transmission", tranT))
Render(trans)

local shader = ShaderRSLPrim()
--shader:setShader("shinymetal")
--shader:addPrimVar(PrimVar("texturename",String("raytrace")))

----------------

local p = Particles(particleAmount)
local p3 = Particles(particleAmount)

local points = p:getPosition()
local widths = p:getWidths()
local colours = p:getColours()
local velocity = p:getVelocity()
local mass = p:getMass()

local points2 = p3:getPosition()
local widths2 = p3:getWidths()
local colours2 = p3:getColours()
local velocity2 = p3:getVelocity()
local mass2 = p3:getMass()

for i=0, points:size()-1 do
	widths:setElement(i, Float(radius))
	points:setElement(i, startVec)
end

for i=0, points2:size()-1 do
	widths2:setElement(i, Float(radius))
	points2:setElement(i, startVec)
end

local plane = Plane(5,5)
plane:transform(Scale(500,200,500)*Rotate(3.1415/2,0,0)*Aim(Vector(0,1,0),planeNormal)*Translate(0,-10,0))
plane:addProperty(shader)
Render(plane)

local c1 = p
local c2 = p3
local b1
local b2
local b = nil
for frame=1, 100 do
	
	local at = Vector(0,0- 9.80665/25 ,0) 
	for i=0, points:size()-1 do
		if i > frame*particleRate then	
			points:setElement(i, startVec)
		else
			velocity:setElement(i, velocity:getElement(i)+at)
		end
	end
	
	-- point point collision --
	local count = 0
	for i=0, (points:size()-1) *0.5 do
		for j=math.floor((points:size()-1) *0.5), points:size()-1 do
			if (points:getElement(i)-points:getElement(j)):length() <= radius*2 then
	
				local c = Vector(0.5)
				
				local V1 = velocity:getElement(i)
				local V2 = velocity:getElement(j)
				
				local M1 = Vector(mass:getElement(i):getData())
				local M2 = Vector(mass:getElement(j):getData())
				
				local VF1 = ((c+Vector(1))*M2*V2 + V1*(M1-c*M2))/(M1+M2)
				local VF2 = ((c+Vector(1))*M1*V1 + V2*(M2-c*M1))/(M2+M1)
				
				velocity:setElement(i, VF1)
				velocity:setElement(j, VF2)
				
				count = count + 1
			--	print(i.." "..j)
			end
		end	
	end

	-- floor collision --
	for i=0, points:size()-1 do		
		local t =  math.abs(
			intersect(points:getElement(i), velocity:getElement(i), planePoint, planeNormal))
			
		if t <= 1.1  then		
			print("Frame: "..frame.." | "..i.." | "..t)
			
			velocity:setElement(i, 
				Vector(0)-
				((Vector(velocity:getElement(i):dot(planeNormal)*2)*planeNormal)-
					velocity:getElement(i)):scale(
						Vector(Rand(0,0.5),Rand(0,0.5),Rand(0,0.5))))			
		end
	end
	
	--------------------

	print("   Collilsions: "..count)

	if frame ~= 1 then	
		unRender(b)
	end
	
	if frame ~= 1 then	
		b1 = b2
	end
	
	local curves = Curves()	
	local k=0
	for i=0, (points:size()-1)/particleRate do
		local c = AttributeVector(10)
		for j=0, 9 do		
			c:setElement(j, points:getElement(k))
			k=k+1
		end
		curves:addCurve(c)
	end

	
	p2 = Particles(0,particleAmount)
	for i=0, (curves:getAmount()-1) do
		local counter = 0
		local totalBs = 500
		local ca = curves:CurveLength(i) *3
		if ca ~= 0 then			
			for j=0, math.floor(ca) do
				local w = (1-((1/ca)*j))^3
				p2:addPoint(curves:getPointAt(i,(1/ca)*j), w)
				counter=counter+1
			end
			for j=0, math.floor(totalBs-ca) do
				p2:addPoint(curves:getPoint(i,0),radius*0.1)
				counter=counter+1
			end
		--	print(math.floor(ca)+math.floor(50-ca))
		else
			for j=0, math.floor(totalBs) do
				p2:addPoint(curves:getPoint(i,0),radius*0.1)
				counter=counter+1
			end			
		end
		if counter >= totalBs+2 then
			print(i..": "..counter.." > "..totalBs)
		end
	end
	
	c1:nextFrame()	









-----------------------------------------------------------------------------------------------



	for i=0, points2:size()-1 do
		if i > frame*particleRate then	
			points2:setElement(i, startVec)
		else
			velocity2:setElement(i, velocity2:getElement(i)+at)
		end
	end

	
	-- point point collision --
	local count = 0
	for i=0, (points2:size()-1) *0.5 do
		for j=math.floor((points2:size()-1) *0.5), points2:size()-1 do
			if (points2:getElement(i)-points2:getElement(j)):length() <= radius*2 then
	
				local c = Vector(0.5)
				
				local V1 = velocity2:getElement(i)
				local V2 = velocity2:getElement(j)
				
				local M1 = Vector(mass2:getElement(i):getData())
				local M2 = Vector(mass2:getElement(j):getData())
				
				local VF1 = ((c+Vector(1))*M2*V2 + V1*(M1-c*M2))/(M1+M2)
				local VF2 = ((c+Vector(1))*M1*V1 + V2*(M2-c*M1))/(M2+M1)
				
				velocity2:setElement(i, VF1)
				velocity2:setElement(j, VF2)
				
				count = count + 1
			--	print(i.." "..j)
			end
		end	
	end

	-- floor collision --
	for i=0, points2:size()-1 do		
		local t =  math.abs(
			intersect(points2:getElement(i), velocity2:getElement(i), planePoint, planeNormal))
			
		if t <= 1.1  then		
			print("Frame: "..frame.." | "..i.." | "..t)
			
			velocity2:setElement(i, 
				Vector(0)-
				((Vector(velocity2:getElement(i):dot(planeNormal)*2)*planeNormal)-
					velocity2:getElement(i)):scale(Vector(Rand(0,0.5),Rand(0,0.5),Rand(0,0.5))))			
		end
	end
	
	print("   Collilsions: "..count)
	
	c2:nextFrame()	
	
	--------------------




-----------------------------------------------------------------------------------------------
	


	
	startVec = startVec+Vector(Rand(0,1),0,Rand(0,1))




	for i=0, points2:size()-1 do	
		p2:addPoint(points2:getElement(i))--, widths2:getElement(i) )--, mass2:getElement(i), velocity2:getElement(i))
	end


	
	bo = Blobbies(p2)
	bo:addProperty(shader)
	b2 = bo

	if frame ~= 1 then	
		b = Blurred(b2, b1)
		Render(b)
	end
	
	camera:outputTIF("renders/particles11."..pad(frame)..".tif")
	output("RIB", "ribs/particles11."..pad(frame)..".rib")	
	
end

