require("custardCream")

-----------------------------------------------------------------------------------------------
-- point(ray) , plane intersection 
-----------------------------------------------------------------------------------------------
function intersect(rOrigin, rNormal, pOrigin, pNormal)
    local D = pOrigin:dot(pNormal);

    local numer = pNormal:dot(rOrigin) + D;
    local denom = pNormal:dot(rNormal);
    return 0-(numer / denom);
end

-----------------------------------------------------------------------------------------------
-- main stuff:
-----------------------------------------------------------------------------------------------

--- settings ---

local planePoint = Vector(0,10,0)
local planeNormal = Vector(0.2,1,-0.4)
local radius = 0.3
local particleAmount = 100000
local particleRate = 5000

local startVec = Vector(-10,20,-10)

----------------

local p = Particles(particleAmount)

local points = p:getPosition()
local widths = p:getWidths()
local colours = p:getColours()
local velocity = p:getVelocity()

for i=0, points:size()-1 do
	widths:setElement(i, Float(radius))
	points:setElement(i, Vector(0,20,0))
end

camera:transform(Translate(0, 0, 500))
camera:setRes(720, 576)

local plane = Plane(5,5)
plane:transform(Scale(200,200,200)*Rotate(3.1415/2,0,0)*Aim(Vector(0,1,0),planeNormal)*Translate(0,-10,0))
Render(plane)

local c1 = p
local c2 = p
local b1
local b2
local b = nil
for frame=1, 150 do
	
	local at = Vector(0,0- 9.80665/25 ,0) 
	for i=0, points:size()-1 do
		if i > frame*particleRate then	
			points:setElement(i, startVec)
		else
			velocity:setElement(i, velocity:getElement(i)+at)
		end
	end
	
	startVec = startVec+Vector(Rand(0,1),0,Rand(0,1))
	
	for i=0, points:size()-1 do	
		local t =  math.abs(intersect(points:getElement(i), velocity:getElement(i), planePoint, planeNormal))
		if t <= 1.1  then
			print("Frame: "..frame.." | "..i.." | "..t)
			velocity:setElement(i, 
				Vector(0)-
				((Vector(velocity:getElement(i):dot(planeNormal)*2)*planeNormal)-velocity:getElement(i))
					:scale(Vector(Rand(0,0.5),Rand(0,0.5),Rand(0,0.5)) ))
		end
	end
	--[[
	-- point point collision --
	for i=0, (points:size()-1) *0.5 do
		for j=math.floor((points:size()-1) *0.5), points:size()-1 do
			if (points:getElement(i)-points:getElement(j)):length() <= radius*2 then
			--	points:setElement(i, (points:getElement(i)*0.5)+
			--	print(i.." "..j)
			end
		end	
	end
	--------------------------
	]]--
	--- blobbys ---
	local blobbys = Primitive("Blobby")
	blobbys:addPrimVar(PrimVar("", Int(points:size())))
	local bInts = AttributeInt(points:size()*3 + 10)
	local j=0	
	for i=0, points:size()-1 do
		bInts:setElement(j, Int(1001))
		bInts:setElement(j+1, Int(i*16))
		j=j+2
	end
	bInts:setElement(j, Int(0))
	bInts:setElement(j+1, Int(points:size()))
	j=j+2
	for i=0, points:size()-1 do
		bInts:setElement(j, Int(i))
		j=j+1
	end	
	blobbys:addPrimVar(PrimVar("", bInts))
	local bMatrix = AttributeMatrix(points:size())
	for i=0, points:size()-1 do
		bMatrix:setElement(i, Scale(Vector(widths:getElement(i):getData())) * Translate(points:getElement(i)))
	end	
	blobbys:addPrimVar(PrimVar("", bMatrix))
	local bString = AttributeString(1)
	bString:setElement(0, String(""))
	blobbys:addPrimVar(PrimVar("", bString))
	--------------
	
	if frame == 1 then
		b1 = blobbys
	end
	
	b2 = blobbys
	
	unRender(b)

	c1:nextFrame()	
	
	b = Blurred(b1, b2)
	Render(b)
	
	camera:outputTIF("renders/particles4b."..frame..".tif")
	output("RIB", "ribs/particles4b."..frame..".rib")		

	b1 = blobbys

end

