require("custardCream")


function randomPointOnQuad(poly)
	xR = Vector(Rand())
	yR = Vector(Rand())

	top = (xR*poly:getElement(0)) + ((Vector(1)-xR)*poly:getElement(1))
	bottom = (xR*poly:getElement(3)) + ((Vector(1)-xR)*poly:getElement(2))

	final = (yR*top) + ((Vector(1)-yR)*bottom);

	--print(final)
	return final
end

function makeGrass(poly, element, curves)
	poly = plane:getPolygon(element);

	for i=1, 2 do
		local length = Rand(0.01, 0.05)
--		print(randomPointOnQuad(poly))
		local blade = AttributeVector(0,4)
		local point = randomPointOnQuad(poly)
		blade:setElement(0, point)
		blade:setElement(1, point)
		blade:setElement(2, point + Vector(Rand(-0.01, 0.01), Rand(-0.01, 0.01), 0-length))
		blade:setElement(3, point + Vector(Rand(-0.01, 0.01), Rand(-0.01, 0.01), 0-length))
		curves:addCurve(blade)
	end
--	print("added curves, element: "..element)
end

------------------------------------------------------------------------------------------------------------------

Render(TransformPrim(Rotate(45,0,0) * Translate(0,0,5)))

plane = Plane(100, 100)
print("Created Plane.")
plane:generateNormalsDirty();	
print("Generate Normals.")
points = plane:getPoints()
print("Got Points: \""..points:size().."\".")
for i=0, points:size()-1 do
	point = points:getElement(i);
	
	noise = (
			voronoi_F1(point:getX()*20.0, point:getY()*20.0 ,0) *0.1 
			+ voronoi_F1(point:getX()*10.0, point:getY()*10.0 ,0) *0.05
			+ newPerlin(point:getX()*50, point:getY()*50, 0) * 0.02
			)
			* newPerlin(point:getX()*5, point:getY()*5, 0) 
						
	points:setElement(i,  Vector(  point:getX(), point:getY(), noise ))
end
print("Added Noise.")
plane:generateNormalsDirty();	
print("Generate Normals.")


------------------------------------------------------------------------------------------------------------------

local curves = Curves();

for i=0, (plane:getNPolys()):size()-1 do
	makeGrass(plane, i, curves)
end

curves:setWidth(Float(0.0015))
Render(curves)

Render(plane)

output("RIB", "grass.rib")
--outputGL()

