require("custardCream")

camera:transform(Rotate(45,0,0) * Translate(0,0,5))

l1 = LightPointPrim()
l1:setFrom(Vector(-5,-2, 0))
l1:setIntensity(30)
Render(l1)

l2 = LightPointPrim()
l2:setFrom(Vector(5,-2, 0))
l2:setIntensity(30)
Render(l2)

plane = Plane(500, 500)
print("Created Plane.")

points = plane:getPoints()
print("Got Points: \""..points:size().."\".")

for i=0, points:size()-1 do
	point = points:getElement(i);
	
	noise = (
			voronoi_F1(point:getX()*20.0, point:getY()*20.0 ,0) *0.1 
			+ voronoi_F1(point:getX()*10.0, point:getY()*10.0 ,0) *0.05
			+ newPerlin(point:getX()*50, point:getY()*50, 0) * 0.02
			)
			* newPerlin(point:getX()*5, point:getY()*5, 0) 
						
	points:setElement(i,  Vector(  point:getX(), point:getY(), noise ))
end
print("Added Noise.")

--plane:triangulate()

plane:generateNormalsDirty();	
print("Generate Normals.")

s1 = ShaderRSLPrim()
s1:setShader("wood")
plane:addProperty(s1)

Render(plane)

cube = Cube(5,5,5)
cube:transform(Scale(0.1,0.1,0.1))

--s2 = ShaderRSLPrim()
--s2:setShader("wood")
cube:addProperty(s1)

Render(cube)

output("RIB", "terrian.rib")
--output("GLUT")
