require("custardCream")

function math.Fibonacci(n)
	return  ((1+math.sqrt(5))^n-(1-math.sqrt(5))^n)/(2^n*math.sqrt(5)) 
end

SRand(os.time())

----------- Set Tree Settings ----------- 

	set = {}
	set.min = {}
	set.max = {}

	set.min.depth = 1
	set.max.depth = 10

	set.min.height = 10
	set.max.height = 20

	set.min.strech = 0.5
	set.max.strech = 0.8
	
	set.min.bend = 0.6
	set.max.bend = 1	
	
------------------------------------------

function randDir(old, min, max)
		local bend = Rand(min, max)
		local cross = old:cross(Vector(Rand(-1,1), Rand(-1,1), Rand(-1,1)))
		cross:normalize()
		
		local newDir 
		if bend > 0 then 
			newDir = Vector(bend) * old + Vector(1-bend) * cross
		else
			print("??")
			newDir = Vector((0-bend)) * (Vector(0)-old) + Vector(1-(0-bend)) * cross
		end	
		return newDir
end



function tree(depth, point, direction, curves) 
	if depth < Rand(set.min.depth, set.max.depth) then
		depth = depth + 1	
	
--		print(depth.." "..tostring(point))
		
		local branch = AttributeVector(0,set.max.height)
		branch:setElement(0,  point )
		branch:setElement(1,  point )
		
		local newPoint = Vector(0)
		local oldPoint
		
		local newDir1 = randDir(direction, set.min.bend, set.max.bend)
		local newDir2 = randDir(direction, set.min.bend, set.max.bend)
		
	--	print(bend)
		
		local segs = Rand(set.min.height, set.max.height)+1
		
		for i=2, segs do
			
			oldPoint = newPoint
		
			local usedDir  = Vector(i/segs) * newDir1 + Vector(1-(i/segs) ) * newDir2
			
			newPoint =   newPoint + usedDir *  
							Vector((Rand(1/math.Fibonacci(depth))+0.5) 
									* Rand(set.min.strech, set.max.strech))
			
			branch:setElement(i,  newPoint+point --)
								+ Vector(Rand(-1,1), Rand(-1,1), Rand(-1,1))*Vector(Rand(0.1)) )
			
			direction = (newPoint - oldPoint):normalized()
			
			if Rand() < 0.15 then
				tree(depth, newPoint+point, newDir2, curves)
			end		
			print("  "..tostring(newPoint+point))
		end
		for j=0, Rand(2) do
			tree(depth, newPoint+point, newDir2, curves)
		end
		
		branch:setElement(branch:size(),  newPoint+point )
		curves:addCurve( branch )
		
	end
end


--[[ -- Fibonacci Series --
for n=0, 1000 do
	print(n.. " " .. ((1+math.sqrt(5))^n-(1-math.sqrt(5))^n)/(2^n*math.sqrt(5)) )
end ]]--


Render(Transform(Translate(0, -10, 300)))

curves = Curves()
tree(0, Vector(0), Vector(0,1,0), curves)

curves:setWidth(Float(0.07))
Render(curves)

outputRIB("tree.rib")
--outputGL()
