require("custardCream")

function math.Fibonacci(n)
	return  ((1+math.sqrt(5))^n-(1-math.sqrt(5))^n)/(2^n*math.sqrt(5)) 
end

----------- Set Tree Settings ----------- 

	set = {}
	set.min = {}
	set.max = {}

	set.min.depth = 10
	set.max.depth = 10

	set.min.height = 5
	set.max.height = 20

	set.min.strech = 0.6
	set.max.strech = 0.9
	
	set.min.bend = 0.4
	set.max.bend = 1	
	
	set.min.brach = 0.1
	set.max.brach = 0.3		
	
------------------------------------------

function randDir(old, min, max)
		local bend = Rand(min, max)
		local cross = old:cross(Vector(Rand(-1,1), Rand(-1,1), Rand(-1,1)))
		cross:normalize()
		
		local newDir 
		if bend > 0 then 
			newDir = Vector(bend) * old + Vector(1-bend) * cross
		else
			print("??")
			newDir = Vector((0-bend)) * (Vector(0)-old) + Vector(1-(0-bend)) * cross
		end	
		return newDir
end



function tree(set) 

	curves = Curves()
	curves:setWidth(Float(0.07))
	
	Render(curves)
	
	local count = 0
	
	local splits = {}

	local toDepth = Rand(set.min.depth, set.max.depth)
	for depth=1, toDepth do
		print(depth)

		if depth == 1 then
			splits[depth] = {}
			splits[depth][1] = {}
			splits[depth][1].point = Vector(0)
			splits[depth][1].direction = Vector(0,1,0)
		end
		
		splits[depth+1] = {}	
		local splitCount = 1
		
		if splits[depth] ~= nil then
			for k, split in pairs(splits[depth]) do
		--	for split=1, #split do
	--			print("  "..k)
				
				local point = split.point
				local direction = split.direction
				
				local branch = AttributeVector(0,set.max.height)
				branch:setElement(0,  point )
				branch:setElement(1,  point )
				
				local newPoint = Vector(0)
				local oldPoint

				local newDir1 = randDir(direction, set.min.bend, set.max.bend)
				local newDir2 = randDir(direction, set.min.bend, set.max.bend)

				local segs = Rand(set.min.height, set.max.height)+1
				
				
				
				for i=2, segs do

					oldPoint = newPoint
				
					local usedDir  = Vector(i/segs) * newDir1 + Vector(1-(i/segs) ) * newDir2
						
				--	Vector(Rand(1/math.Fibonacci(depth)+0.5) * Rand(set.min.strech, set.max.strech))	
						
					newPoint =   newPoint + (usedDir * Vector(1/math.Fibonacci(depth) + 0.5 ) * Vector(Rand(set.min.strech, set.max.strech)))

					branch:setElement(i,  newPoint+point --)
										+ Vector(Rand(-1,1), Rand(-1,1), Rand(-1,1))*Vector(Rand(0.1)) )
					
					direction = (newPoint - oldPoint):normalized()
						
					if Rand() < Rand(set.min.brach, set.max.brach) then		
						splits[depth+1][splitCount] = {}
						splits[depth+1][splitCount].point = newPoint+point
						splits[depth+1][splitCount].direction = newDir2
					--	print(splits[depth+1][splitCount].point)
						splitCount = splitCount + 1
					end		

				end	
				
				local spiltA = Rand(2.5)
				for j=0, spiltA do
					if spiltA >1  then
						splits[depth+1][splitCount] = {}
						splits[depth+1][splitCount].point = newPoint+point
						splits[depth+1][splitCount].direction = newDir2
					--	print(splits[depth+1][splitCount].point)
						splitCount = splitCount + 1
					end
				end		
					
				branch:setElement(branch:size(),  newPoint+point )
				curves:addCurve( branch )		
			
			end
			
		end
		
		count = count + splitCount
		print(depth..": "..count)
		camera:outputTIF("tree."..frame..".tif")
		outputRIB("tree."..frame..".rib")
		frame = frame + 1
		
	end
	
	return curves
end

frame = 0;

SRand(os.time())
local srand = Rand(10000)
local srand = 9794
print("Seed: "..srand)
SRand(srand)



Render(Transform(Translate(0, -17, 300)))


--Render(tree())
tree(set)


--camera:outputTIF("tree."..frame..".tif")
outputRIB("tree."..frame..".rib")


