#ifndef BTWORLD_H
#define BTWORLD_H

#include <vector>
#include <iostream>

#include "bullet/btBulletDynamicsCommon.h"

/// Enough for some maths
#include "bullet/LinearMath/btIDebugDraw.h"
#include "bullet/LinearMath/btAlignedObjectArray.h"
#include "bullet/LinearMath/btQuickprof.h"
#include "bullet/LinearMath/btIDebugDraw.h"

#include "bullet/LinearMath/btScalar.h"
#include "bullet/LinearMath/btQuadWord.h"
#include "bullet/LinearMath/btVector3.h"
#include "bullet/LinearMath/btPoint3.h"
#include "bullet/LinearMath/btQuaternion.h"
#include "bullet/LinearMath/btMatrix3x3.h"
#include "bullet/LinearMath/btTransform.h"
#include "bullet/LinearMath/btMotionState.h"
#include "bullet/LinearMath/btDefaultMotionState.h"

/// Enough for constraints
#include "bullet/BulletDynamics/ConstraintSolver/btGeneric6DofConstraint.h"
#include "bullet/BulletDynamics/Dynamics/btRigidBody.h"

//#include "bullet/BulletCollision/CollisionDispatch/btCollisionObject.h"
#include "bullet/BulletCollision/CollisionDispatch/btCollisionDispatcher.h"
#include "bullet/BulletCollision/BroadphaseCollision/btOverlappingPairCache.h"
#include "bullet/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h"
#include "bullet/BulletDynamics/ConstraintSolver/btSequentialImpulseConstraintSolver.h"
#include "bullet/BulletDynamics/Dynamics/btDiscreteDynamicsWorld.h"

#include "bullet/BulletCollision/CollisionDispatch/btCollisionWorld.h"

/// Enough for a basic world setup
#include "bullet/BulletDynamics/Dynamics/btDynamicsWorld.h"
#include "bullet/BulletDynamics/ConstraintSolver/btPoint2PointConstraint.h"
#include "bullet/BulletDynamics/ConstraintSolver/btHingeConstraint.h"
#include "bullet/BulletCollision/CollisionShapes/btCollisionShape.h"
#include "bullet/BulletCollision/CollisionShapes/btConvexShape.h"
#include "bullet/BulletCollision/CollisionShapes/btPolyhedralConvexShape.h"
#include "bullet/BulletCollision/CollisionShapes/btBoxShape.h"
#include "bullet/BulletCollision/CollisionShapes/btSphereShape.h"
#include "bullet/BulletCollision/CollisionShapes/btMultiSphereShape.h"
#include "bullet/BulletCollision/CollisionShapes/btCompoundShape.h"

#include "bullet/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h"

#include "bullet/LinearMath/btMotionState.h"
#include "bullet/LinearMath/btDefaultMotionState.h"

btBoxShape *btBoxShapeNew( btVector3 hwd );

class btWorld {
	public:
		btWorld();
		btWorld( btVector3 gravity );
		~btWorld();
		btRigidBody *btWorld::RigidBody( btTransform startTransform, btCollisionShape *shape, double mass );
		#if 0
		void step();
		#endif
		std::vector<btTransform> getTransforms();
		btDynamicsWorld &getWorld();
	private:
        btCollisionDispatcher  *dispatcher ;
        btOverlappingPairCache *broadphase ;
        btSequentialImpulseConstraintSolver *solver ;
        btDiscreteDynamicsWorld *dynamicsWorld;
    public:
    	std::vector<btCollisionShape*> collisionShapes ;
};

#endif

