""" 
    All variables declared in this script are local to this script.
"""

import luyaUtils as lu
from mayaUtils import *
from Fuzzy import *
import Fuzzy
reload(Fuzzy)
from fuzzyRules import *
import luyaODE as luya
reload(luya)
from math import pi,degrees,radians
from maya.api import MVector,MQuaternion
from maya.mel import *

import jointTrackerFuzzy as Tracker
reload(Tracker)

import clearKeyframes
reload(clearKeyframes)

N= None
halfPi = pi / 2

def makeMotor(w,knee):
    """ Given a joint makes a motor for it """
    parent = knee.getBody(0)
    child = knee.getBody(1)
    
    cap = luya.ode.AMotor(w.w)
    cap.attach(parent, child)
    
    cap.setMode(luya.ode.AMotorEuler)
    
    cap.setAxis( 0, 1, (1,0,0 ))
    cap.setAxis( 2, 2, (0,0,1 ))
    
    cap.setAngle(0,0)
    cap.setAngle(1,0)
    cap.setAngle(2,0)
    
    mstop = pi
    strength = 100000
    
    cap.setParam(luya.ParamFMax,strength)
    #cap.setParam(luya.ParamLoStop,-mstop)
    #cap.setParam(luya.ParamHiStop,mstop)
    
    cap.setParam(luya.ParamFMax2,strength)
    #cap.setParam(luya.ParamLoStop2,-mstop/200000)
    #cap.setParam(luya.ParamHiStop2,mstop/200000)
    
    cap.setParam(luya.ParamFMax3,strength)
    #cap.setParam(luya.ParamLoStop3,-mstop)
    #cap.setParam(luya.ParamHiStop3,mstop)
    
    return cap

def applyAngularVelocity( motor, Q, kP=10 ):
    Euler = Q.asEulerRotation()
    motor.setParam( luya.ParamVel,  kP*Euler.x )
    motor.setParam( luya.ParamVel2, kP*Euler.y )
    motor.setParam( luya.ParamVel3, kP*Euler.z )

def init( g ):
    """ The Physics Part """
    g.w = luya.World()
    g.w.motors = luya.atom()
    
    for i in g.w.joints.values() :
        i.motor = makeMotor( g.w, i.joint )
    
    g.w.tracker = Tracker.jointTracker()
    
    g.log = open("/bacva3/ltitley/Devel/Luya/fuzzy_logic/fuzzy.txt","w")

def run( g ):
    
    for name in g.w.joints.keys():
        joint = g.w.joints[name]
        motor = joint.motor
        Current = Translate(joint.child) - Translate(name)
        Q = g.w.tracker( Current )
        applyAngularVelocity( motor, Q, 1 )
    
#    if g.time == 12:
#        g.w.dynamics.shin_knee_thi_transform1_knee1_upper.body.addForce( (30000,0,0) )
     
#    if g.time == 300:
#        g.w.dynamics.shin_knee_thi_transform1_knee1_upper.body.addForce( (100,0,30000) )

    g.w.step(0.1)

def end( g ):
    g.log.close()

