from pyFuzzy import *
from time import time

class Stepper:
	"""Utility class to help with setting up a linguistic variable"""
	def __init__(self,lower,upper,steps):
		self.lower = float(lower)
		self.upper = float(upper)
		if type(steps) == type(0) or type(steps) == type(0.0):
			self.stepsize = (self.upper - self.lower ) / float(steps - 1 )
			self.steps = None
		else:
			self.steps = steps
			self.stepsize = None
	def step(self,num):
		if self.stepsize != None:
			return self.lower + ( float(num) * self.stepsize )
		else:
			return self.steps[num]
	def __call__(self,num):
		return self.step(num)

if __name__ == "__main__" :
	scale  = 90
	u = Stepper(-scale*3, scale*3,[ -3*scale, -scale, scale, 3*scale ])
	Angle = InputVariable (u.lower,u.upper,(
	    ("Low" , Linear(u(0),u(1)), Linear(u(1),u(2))),
	    ("High", Linear(u(1),u(2)), Linear(u(2),u(3)))
	))
	
	strength  = 90
	u = Stepper(-strength*3, strength*3,[ -3*strength, -strength, strength, 3*strength ])
	AngularSpeed = OutputVariable (u.lower,u.upper,(
	    ("Low" , Linear(u(0),u(1)), Linear(u(1),u(2))),
	    ("High", Linear(u(1),u(2)), Linear(u(2),u(3)))
	))
	print "Start"
	starty = time()
	for i in range(1000000):
		start = time()
		Angle.fuzz(90)
		AngularSpeed.begin()
		
		f_if( f_is( Angle, "High" ), [ ( AngularSpeed, "High" ) ] )
		f_if( f_is( Angle, "Low" ), [ ( AngularSpeed, "Low" ) ] )
		
		AngularSpeed.defuzz( (300,100), "/bacva3/ltitley/workspace/cFuzzy/scripts/fuzzyFrames/fuzzTest.xpm")

	print str( time() - starty )
	print "End"
