from Fuzzy import *
from fuzzyRules import *

print "\n\n\n\n\n\n\n"

scale  = 180
u = Stepper(-scale,scale,[-scale*2,-scale,0,scale,scale*2])
Angle = InputVariable (u.lower,u.upper,(
    ("-High" , Linear(u(0),u(1)),  Linear(u(1),u(2))),
    ("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3))),
    ("+High" , Linear(u(2),u(3)),  Linear(u(3),u(4)))
))
del scale
del u

scale  = 180
u = Stepper(-scale,scale,[-scale*2,-scale,0,scale,scale*2])
AngularVelocity = InputVariable (u.lower,u.upper,(
    ("-High" , Linear(u(0),u(1)),  Linear(u(1),u(2))),
    ("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3))),
    ("+High" , Linear(u(2),u(3)),  Linear(u(3),u(4)))
))
del scale
del u

scale  = 180.0
u = Stepper(-scale,scale,[-scale*2,-scale,0,scale,scale*2])
Torque = OutputVariable (u.lower,u.upper,(
    ("-High" , Linear(u(0),u(1)),  Linear(u(1),u(2))),
    ("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3))),
    ("+High" , Linear(u(2),u(3)),  Linear(u(3),u(4)))
))
del scale
del u

ruleSet = interpret(\
"""
    if Angle is -High and AngularVelocity is -High : Torque = +High
    if Angle is +High and AngularVelocity is +High : Torque = -High
    if Angle is +High and AngularVelocity is -High : Torque = Zero
    if Angle is -High and AngularVelocity is +High : Torque = Zero
"""
)

j=0
for i in range(-100,100) :
    
    Angle.fuzz( float(i) )
    AngularVelocity.fuzz( -float(i)*2 )
    
    Torque.begin()
    exec(ruleSet)
    
    print Torque.defuzz(filename="./fuzzframes/out_%s.xpm" % str(j).zfill(4) )
    j+=1

