"""
 Behaviour initialization for an ODE luya world.
"""

import os

print os.getcwd()

print "Starting"

import luya_api as luya
reload(luya)

import fuzzy
reload(fuzzy)

from fuzzyApi import *
import fuzzyRules as rules
reload(rules)

########Fuzzy Logic Part

##Variables
#The velocity of the angular change in the inverse pendulum

u = Stepper(-90,90,[-30,-10,0,10,30])
Angle = InputVariable (u.lower,u.upper,(
	("-High" , Singleton(u.lower),   Linear(u(0),u(1)) ),
	("-Low" ,  Linear(u(0),u(1)), Linear(u(1),u(2)) ),
	("Zero" ,  Linear(u(1),u(2)), Linear(u(2),u(3)) ),
	("Low" ,   Linear(u(2),u(3)), Linear(u(3),u(4)) ),
	("High" ,  Linear(u(3),u(4)), Singleton(u.upper))
))

#The strength of the torque force needed to keep the inverse pendulum uprite
u = Stepper(-25,25,[-5,-2,0,2,5])
TorqueStrength = OutputVariable (u.lower,u.upper,(
	("-High" , Singleton(u.lower),	   Linear(u(0),u(1)) ),
	("-Low" ,  Linear(u(0),u(1)),  Linear(u(1),u(2)) ),
	("Zero" ,  Linear(u(1),u(2)),  Linear(u(2),u(3)) ),
	("Low" ,   Linear(u(2),u(3)),  Linear(u(3),u(4)) ),
	("High" ,  Linear(u(3),u(4)),  Singleton(u.upper))
))

##Rules
ruleset_src = \
"""
	if Angle is -High: TorqueStrength = High
	if Angle is -Low: TorqueStrength = Low
	if Angle is Zero: TorqueStrength = Zero
	if Angle is Low: TorqueStrength = -Low
	if Angle is High: TorqueStrength = -High
"""

ruleset = rules.interpret(ruleset_src)

########Physics Part

#Initialize the world
w = luya.World()

#box = luya.ode.GeomBox(w.space,lengths=(10,1,10))
#box.setPosition((0,2,0))

knee = w.dynamics.shin_knee.joint
parent = knee.getBody(0)
child = knee.getBody(1)

#w.w.setCFM(1)

cap = luya.ode.AMotor(w.w)
cap.attach(parent, child)

cap.setMode(luya.ode.AMotorEuler)
cap.setFeedback(True)

#cap.setNumAxes(1)

cap.setAxis( 0, 1, (1,0,0 ))
#cap.setAxis( 1, 1, (0,1,0 ))
cap.setAxis( 2, 2, (0,0,1 ))

cap.setAngle(0,0)
cap.setAngle(1,0)
cap.setAngle(2,0)

mstop = 100.0

cap.setParam(luya.ParamFMax,10000)
cap.setParam(luya.ParamLoStop,-luya.pi/mstop)
cap.setParam(luya.ParamHiStop,luya.pi/mstop)

cap.setParam(luya.ParamFMax2,10000)
cap.setParam(luya.ParamLoStop2,-luya.pi/mstop)
cap.setParam(luya.ParamHiStop2,luya.pi/mstop)

cap.setParam(luya.ParamFMax3,10000)
cap.setParam(luya.ParamLoStop3,-luya.pi/2)
cap.setParam(luya.ParamHiStop3,luya.pi/2)
