"""
 Running behaviour for Luya ODE world.
 The behaviour is run on a per frame basis.
"""

from maya.api import MVector,MQuaternion
from math import acos,degrees,radians

parentV = MVector(xform("knee",ws=N,q=N,t=N))
thiV = MVector(xform("thi",ws=N,q=N,t=N)) - parentV
thiV.normalize()
upV = MVector(1,0,0)

angle = 90 - degrees(thiV.angle(upV))

if time <= 1:
	w.dynamics.shin_knee_thi.body.addForce((1000,0,0))
	pass
else:
	angleV = angle - lastAngle

	#print "Angle: %s" % angle
	#print "AngleV: %s" % angleV

	Angle.fuzz(angle)

	exec(ruleset)
	
	torqueStrength = TorqueStrength.defuzz(rez=(500,250))

	print torqueStrength
	
	cap.setParam(luya.ParamVel3,torqueStrength)

lastAngle = angle

w.step(0.05)
